class Particule
{
  float x,y,z; // position
  float vx,vy,vz; // vitesse
  float ax,ay,az; // acceleration
  float masse; // masse 
  float dimension; // pour le dessin
  float age,ageMax;


    // Constructeur
  Particule(float x, float y, float z, float m, float dimension)
  {
    this.x = x;
    this.y = y;
    this.z = z;
    this.masse = m;
    this.dimension = dimension;
    this.ax = this.ay = this.az = 0;
    initRandomSpeed();
    this.age = 0;
    this.ageMax = (int)random(15,45);
  }

  // Methode update
  void update()
  {
    // acceleration
    this.ax = gx / this.masse;
    this.ay = gy / this.masse;
    this.az = gz / this.masse;
    
    // vitesse
    this.vx = this.vx + this.ax;
    this.vy = this.vy + this.ay;
    this.vz = this.vz + this.az;
    
    // position
    this.x = this.x + this.vx;
    this.y = this.y + this.vy;
    this.z = this.z + this.vz;
    
    age++;
    if (age >= ageMax)
    {
      this.x = this.y = this.z = 0;
      this.ax = this.ay = this.az = 0;
      initRandomSpeed();
      age=0;
    }
  }

  void initRandomSpeed()
  {
    this.vx = random(-1,1);
    this.vy = random(0.1,2);
    this.vz = random(-1,1);
  }

  // Methode draw : dessin de particule
  void draw()
  {
    noStroke();
    float a = 1 - (float)age / (float)ageMax;
    fill(209,0,0,a*255);
    pushMatrix();
    translate(this.x, this.y, this.z);
    box(this.dimension);
    popMatrix();
    
  }
  
} 



