class SphereTangentTransform
{
  PVector x,y,z;
  PVector i,j,k;
  PVector p; // point on the surface

  SphereTangentTransform()
  {
    i = new PVector(1,0,0);
    j = new PVector(0,1,0);
    k = new PVector(0,0,1);

    x = new PVector();
    y = new PVector();
    z = new PVector();

    p = new PVector();
  }

  void computeFromGeoLocation(float latitude, float longitude, float sphereRadius)
  {
    float a = 90-latitude;
    float b = 270-90+longitude;
    p.x = -sphereRadius*sin(radians(a)) * cos(radians(b));
    p.y = -sphereRadius*cos(radians(a));
    p.z = sphereRadius*sin(radians(a)) * sin(radians(b));
    
    float db = 0.5;
    x.x = -sphereRadius*sin(radians(a)) * cos(radians(b+db));
    x.y = p.y;
    x.z = sphereRadius*sin(radians(a)) * sin(radians(b+db));


    this.y.set(p);  
    this.y.normalize();  
    x.sub(p);
    x.normalize();
    this.x.normalize();
    this.z = this.y.cross(this.x);
  }

  PVector getPointSurface()
  {
    return this.p;
  }

  void draw(float l)
  {
    pushMatrix();
    stroke(255,0,0);
    line(0,0,0,l,0,0);
    stroke(0,255,0);
    line(0,0,0,0,l,0);
    stroke(0,0,255);
    line(0,0,0,0,0,l);
    popMatrix();
  }

  void feed()
  {
    translate(p.x,p.y,p.z);
    applyMatrix(
    x.x,y.x,z.x,0,
    x.y,y.y,z.y,0,
    x.z,y.z,z.z,0,
    0,0,0,1
     );
  }
}

